/*
 * bsp_led.h
 *
 *  Created on: 20241216
 *      Author: 123
 */

#ifndef INC_BSP_LED_H_
#define INC_BSP_LED_H_

#include "CH58x_common.h"

#define LED_VALVE_R_PIN GPIO_Pin_7
#define LED_VALVE_G_PIN GPIO_Pin_8
#define LED_VALVE_Y_PIN GPIO_Pin_9
#define LED_ALARM_PIN   GPIO_Pin_9
#define LED_VBAT_PIN    GPIO_Pin_4

#define LED_VALVE_OPEN  {GPIOA_ResetBits(LED_VALVE_R_PIN | LED_VALVE_G_PIN | LED_VALVE_Y_PIN);\
                         GPIOA_SetBits(LED_VALVE_G_PIN);}

#define LED_VALVE_CLOSE  {GPIOA_ResetBits(LED_VALVE_R_PIN | LED_VALVE_G_PIN | LED_VALVE_Y_PIN);\
                         GPIOA_SetBits(LED_VALVE_R_PIN);}

#define LED_ALARM_OPEN   GPIOB_SetBits(LED_ALARM_PIN)

#define LED_ALARM_CLOSE  GPIOB_ResetBits(LED_ALARM_PIN)

#define LED_VBAT_OPEN    GPIOB_SetBits(LED_VBAT_PIN)

#define LED_VBAT_CLOSE   GPIOB_ResetBits(LED_VBAT_PIN)

#define LED_ALL_OPEN     {GPIOA_SetBits(LED_VALVE_R_PIN | LED_VALVE_G_PIN | LED_VALVE_Y_PIN);\
                          GPIOB_SetBits(LED_ALARM_PIN | LED_VBAT_PIN);}

#define LED_ALL_CLOSE     {GPIOA_ResetBits(LED_VALVE_R_PIN | LED_VALVE_G_PIN | LED_VALVE_Y_PIN);\
                          GPIOA_ResetBits(LED_ALARM_PIN | LED_VBAT_PIN);}

void BSP_LED_Init(void);

#endif /* INC_BSP_LED_H_ */
