/*
 * bsp_adc.c
 *
 *  Created on: 20241129
 *      Author: 123
 */
#include "bsp_adc.h"
#include "CONFIG.h"
#include "log.h"

signed short RoughCalib_Value = 0; // ADCֵƫֵ
static tmosTaskID vbat_task_id = INVALID_TASK_ID;
void VBAT_ADC_Init(void)
{
    //ADCʼ
    /* ͨѡadcͨ0Ӧ PA4ţ У׼ */
   GPIOA_ModeCfg(GPIO_Pin_4, GPIO_ModeIN_Floating);
   // 8M
   ADC_ExtSingleChSampInit(SampleFreq_8_or_4, ADC_PGA_1_2);

   RoughCalib_Value = ADC_DataCalib_Rough(); // ڼADCڲƫ¼ȫֱ RoughCalib_Value
   logDebug("RoughCalib_Value =%d \n", RoughCalib_Value);

   ADC_ChannelCfg(0);
   ADC_ExcutSingleConver();//ʱ㹻ʱٴת״ADC
   DelayMs(10);
}

void ADC_GPIO_Init(void)
{
    GPIOA_ModeCfg(GPIO_Pin_4, GPIO_ModeIN_Floating);
}

uint16_t VBAT_ProcessEvent(uint8_t task_id, uint16_t events)
{
    if (events & VBAT_EVT_START)
    {
        uint16_t adc_vbat = 0;
        float vbat = 0;
        ADC_GPIO_Init();

        ADC_ChannelCfg(0);
        adc_vbat = ADC_ExcutSingleConver() + RoughCalib_Value;
        logDebug("adc_vbat =%d \n", adc_vbat);
        vbat = (adc_vbat/1024.0-1)*1.05;
        logDebug("vbat =%f \n", vbat);
        tmos_start_task(vbat_task_id, VBAT_EVT_START, MS1_TO_SYSTEM_TIME(1000*60));
        return (events ^ VBAT_EVT_START);
    }
    return 0;
}
void BSP_VBAT_Init(void)
{
    VBAT_ADC_Init();
    vbat_task_id = TMOS_ProcessEventRegister(VBAT_ProcessEvent);
    tmos_set_event(vbat_task_id, VBAT_EVT_START);
}
